#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <gsl/gsl_rng.h>
#include <gsl/gsl_randist.h>
#include "nodes.h"

gsl_rng *r;
const gsl_rng_type *T;
key_block key_list[10][10];		//List of key indexes

    
int main()
{
    int total_count, tmp_count, nid, x, y, tmp_x, tmp_y, retvalue, nodes2generate, tmp_nid;
    double rnd_x, rnd_y;

    FILE *fd;
    char msg[10];
    float length;
    int node_key_list[M];
    int nodes[MAXNODES];
    int assigned_nodes = 0;
    int p, q, k, i, rnd_id;
   
    if(node_key_list == NULL)
        printf("No Memory\n");
    
    total_count = 0;
    tmp_count = 0;
    srand(time(NULL));                      //Set the seed for rand()
    gaussian_rnd_init();                    //Initialize Gaussian random number generator
    load_key_ids();                          //Load already generated key IDs
    
    for(i = 0; i< MAXNODES; i++)              //Make the array 0
    {
    	nodes[i] = 0;
        node_key_list[i] = 0;
    }

    
    for(y = 50 ; y < NODESY;)
    {
        for(x = 50 ; x < NODESX;)
        {
            
            if(((x == 150) && (y == 150))  || ((x == 850) && (y == 150)) || ((x == 150) && (y == 850)) || ((x == 850) && (y == 850)))                    
                nodes2generate = NONODES_G3;
            else if(((x == 350) && (y == 50)) || ((x == 650) && (y == 50)) || ((x == 350) && (y == 950)) || ((x == 650) && (y == 950))
                    || ((x == 50) && (y == 350)) || ((x == 950) && (y == 350)) || ((x == 50) && (y == 650)) || ((x == 950) && (y == 650)))
                nodes2generate = NONODES_G2;
            else
                nodes2generate = NONODES_G1;
                    
            length = sqrt((x - STARTX)*(x - STARTX) + (y - STARTY)*(y - STARTY));
            if(length > R)                  //skip if beyound the circle boundary
            {
                x += 100;
                continue;
            }
            
            tmp_count = 0;
            while(1)					//Loop forever
            {
                //generate node's relative X & Y
		rnd_x = gsl_ran_gaussian(r,SIGMA);
		rnd_y = gsl_ran_gaussian(r,SIGMA);					
                
                //Generate node's absolute
                tmp_x = (x + (int)rnd_x) % NODESX;
                tmp_y = (y + (int)rnd_y) % NODESY;
                
                length = sqrt((tmp_x - STARTX)*(tmp_x - STARTX) + (tmp_y - STARTY)*(tmp_y - STARTY));
                if(length <= R)                         //If within circle
                {
                    nid = tmp_y * NODESX + tmp_x + 1;   // Set NIDs from left to right. Set nos from 1
                    if(nodes[nid - 1] == 0)
                    {
                        nodes[nid - 1] = nid;	
                        tmp_count++;
                        total_count++;
                                
                        p = (x - 50)/100;
                        q = (y - 50)/100;
                        
                        for(i = 0; i < M; i++)
                        {
                            rnd_id = rand() % SC;
                            for(k = 0; k < i; k++)
                            {
                                if(node_key_list[k] == key_list[q][p].key_IDs[rnd_id])
                                    break;
                            }
                            if(k == i)
                            {
                                node_key_list[k] = key_list[q][p].key_IDs[rnd_id];
                                break;
                            }
                        }

                        assigned_nodes++;
                        
                        if(tmp_count == nodes2generate)	//Generate upto NONODES nodes
                            break;                       
                    }                                      
                }
            }
            x += 100;
        }
        y += 100;    
    }


/*
    nid = STARTY * NODESX + STARTX + 1;	//If the middle node doesn't exist quit
    if(nodes[nid - 1] == 0)
    {
        for(x = (STARTX - 8); x <= (STARTX + 8); x++)
        {
            for(y = (STARTY - 8); y <= (STARTY + 8); y++)
            {
                tmp_nid = y * NODESX + x + 1;	
                if(nodes[tmp_nid - 1] != 0)
                {
                    nodes[tmp_nid - 1] = 0;
                    nodes[nid - 1] = nid;
                    
                    for(i = 0; i < assigned_nodes; i++)
                    {
                      //  printf("%d\n", node_key_list[0].NID);

                        if(node_key_list[i].NID == tmp_nid)
                        {
                            node_key_list[i].NID = nid;
                            break;
                        }                            

                    }

                }
            }
        }
        if(nodes[nid - 1] == 0)  //If the middle node doesn't exist quit
            exit(0);   
    }
*/
    
/*
    total_count=0;	
    fd = fopen(NODEFILE, "w");

    for(i = 0; i < MAXNODES; i++)
    {
        if(nodes[i] != 0)
        {
            retvalue =  sprintf(msg, "%d\n", nodes[i]);
            fputs(msg, fd);

            //for(k = 0 ; k < NONODES; k++)
            //{              
              //  printf("%d\n", node_key_list[0].NID);
                
                //if(node_keys[k].NID == nodes[i])
                //{
                  //  printf("%d\n", k);
             //       for(l = 0 ; l < M; l++)
                    //{
                       // retvalue =  sprintf(msg, "%d\n", node_keys[k].key_IDs[l]);
                 //       fputs(msg, fd);                 
                  //  }
               // }
            //}
        total_count++;
        }
    }
    
    fclose(fd);
    gaussian_rnd_remove();
*/

    return 0;
}


/*-----------------------------------------------------------------------*
 * Initialize the gaussian random number generator                       *
 *-----------------------------------------------------------------------*/
void gaussian_rnd_init()
{
    unsigned long int seed;
  
    seed = time(NULL); 
    gsl_rng_env_setup();

    T=gsl_rng_default;

    r = gsl_rng_alloc(T);
    gsl_rng_set(r,seed); 
}

/*----------------------------------------------------------------------*
 * Remove the gaussian random number generator                          *
 *----------------------------------------------------------------------*/
void gaussian_rnd_remove()
{
    gsl_rng_free (r);
}

void load_key_ids()
{
    FILE *key_fd;			//File descripter
    char msg[10];			//Hold the string read from the file
    int retvalue;
    uint i, j, k;
    uint tmp_key_id;                    //Holds the key id
      
    key_fd = fopen(KEYFILE, "r");	//Open file as read only
    if(key_fd == NULL)		//If unable to open file
    {
        perror("Error- Key ID file: ");
        exit(1);
    }

    for( i = 0; i < 10; i++)
    {
        for(j = 0; j < 10; j++)
        {
            for(k = 0; k < SC; k++)
            {
                fgets(msg, 10, key_fd);
                retvalue = sscanf(msg, "%d", &tmp_key_id);
                key_list[i][j].key_IDs[k] = tmp_key_id;    
            }           
        }
    }   
}
